<?php

namespace Asadi\Mark\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Asadi\Mark\Interfaces\MarkRepositoryInterface;

class MarkPublicController extends BaseController
{
    // use MarkWorkflow;

    /**
     * Constructor.
     *
     * @param type \Asadi\Mark\Interfaces\MarkRepositoryInterface $mark
     *
     * @return type
     */
    public function __construct(MarkRepositoryInterface $mark)
    {
        $this->repository = $mark;
        parent::__construct();
    }

    /**
     * Show mark's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $marks = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('mark::public.mark.index', compact('marks'))->render();
    }

    /**
     * Show mark.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $mark = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('mark::public.mark.show', compact('mark'))->render();
    }

}
