<?php

namespace Asadi\Mark;

use User;

class Mark
{
    /**
     * $mark object.
     */
    protected $mark;

    /**
     * Constructor.
     */
    public function __construct(\Asadi\Mark\Interfaces\MarkRepositoryInterface $mark)
    {
        $this->mark = $mark;
    }

    /**
     * Returns count of mark.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.mark.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->mark->pushCriteria(new \Litepie\Asadi\Repositories\Criteria\MarkUserCriteria());
        }

        $mark = $this->mark->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('mark::' . $view, compact('mark'))->render();
    }
}
