<?php

namespace Asadi\Mark\Workflow;

use Asadi\Mark\Models\Mark;
use Asadi\Mark\Notifications\Mark as MarkNotifyer;
use Notification;

class MarkNotification
{

    /**
     * Send the notification to the users after complete.
     *
     * @param Mark $mark
     *
     * @return void
     */
    public function complete(Mark $mark)
    {
        return Notification::send($mark->user, new MarkNotifyer($mark, 'complete'));;
    }

    /**
     * Send the notification to the users after verify.
     *
     * @param Mark $mark
     *
     * @return void
     */
    public function verify(Mark $mark)
    {
        return Notification::send($mark->user, new MarkNotifyer($mark, 'verify'));;
    }

    /**
     * Send the notification to the users after approve.
     *
     * @param Mark $mark
     *
     * @return void
     */
    public function approve(Mark $mark)
    {
        return Notification::send($mark->user, new MarkNotifyer($mark, 'approve'));;

    }

    /**
     * Send the notification to the users after publish.
     *
     * @param Mark $mark
     *
     * @return void
     */
    public function publish(Mark $mark)
    {
        return Notification::send($mark->user, new MarkNotifyer($mark, 'publish'));;
    }

    /**
     * Send the notification to the users after archive.
     *
     * @param Mark $mark
     *
     * @return void
     */
    public function archive(Mark $mark)
    {
        return Notification::send($mark->user, new MarkNotifyer($mark, 'archive'));;

    }

    /**
     * Send the notification to the users after unpublish.
     *
     * @param Mark $mark
     *
     * @return void
     */
    public function unpublish(Mark $mark)
    {
        return Notification::send($mark->user, new MarkNotifyer($mark, 'unpublish'));;

    }
}
